

/*
 * The pair of sockets which cross connect
 */
struct tcpslb_sockpair{
	struct socket *srcSock;       //client socket
	struct socket *destSock;      //realserver socket
	struct semaphore sem;         //to synchronize close
	spinlock_t lock;              //to modify cont
	int cont;                     //to decide running of thread
};

/*
 * Structure for Round Robin Scheduling
 */
struct tcpslb_sched_rr{
	struct semaphore sem;
	struct tcpslb_realservers *server;
};

/*
 * Structure for Weighted Round Robin Scheduling
 */
struct tcpslb_sched_wrr{
	struct semaphore sem;
	int weight[MAXSERVERS];
	int history[MAXSERVERS];
	
};

/*
 * Structure for Least connections Scheduling
 */
struct tcpslb_sched_lc{
	struct semaphore sem;
	int connections[MAXSERVERS];
};

/*
 * Structure for Weighted Least connections Scheduling
 */
struct tcpslb_sched_wlc{
	struct semaphore sem;
	int connections[MAXSERVERS];
	int weight[MAXSERVERS];
};
