#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/vmalloc.h>
#include <linux/net.h>
#include <linux/skbuff.h>
#include <linux/unistd.h>
#include <linux/wait.h>
#include <linux/kmod.h>
#include <asm/unistd.h>

#include <net/sock.h>
#include <net/tcp.h>

#include "tcpslb.h"
#include "rrlc.h"
#include "cbs.h"
#include "hash.h"

#define RMMOD "/sbin/rmmod"


struct tcpslb_service *serv;
static int (*tcpslb_accept_cons_generic)(void *service);
static int (*tcpslb_accept_cons_cbs)(void *service);
static int (*tcpslb_accept_cons_hash)(void *service);
//static int (*tcpslb_hash_addnode)(struct tcpslb_sched_hash *sched,int *addr,
//		                struct tcpslb_realservers *dest);
static int tcpslb_start_services(void *data);
static void tcpslb_dealloc_hash(struct tcpslb_hash_node *node);

static int ok=0;
struct semaphore *config_sem;
static int reqd[10];

static int __init tcpslb_init(void)
{
/*     struct tcpslb_realservers *servers;
     struct tcpslb_sched_rr *rr_sched;
     struct tcpslb_sched_wrr *wrr_sched;
     struct tcpslb_sched_lc *lc_sched; 
     struct tcpslb_sched_wlc *wlc_sched;
     struct tcpslb_sched_cbs *cbs_sched;
     struct tcpslb_sched_wcbs *wcbs_sched;
     struct tcpslb_sched_hash *hash_sched;*/

//     int addr[4];
     config_sem=(struct semaphore *)vmalloc(sizeof(struct semaphore));
     sema_init(config_sem,1);
     request_module("tcpslb_rrlc");
     request_module("tcpslb_cbs");
     request_module("tcpslb_hash");
     
     inter_module_register("serv",THIS_MODULE,serv);
     inter_module_register("config_sem",THIS_MODULE,config_sem);
     tcpslb_accept_cons_generic=inter_module_get_request("tcpslb_accept_cons_generic", "tcpslb_rrlc");
     if(tcpslb_accept_cons_generic==NULL){
	     printk("did not get tcpslb_rrlc where is it?");
	     ok=1;
	     return 0;
     }
     tcpslb_accept_cons_cbs=inter_module_get_request("tcpslb_accept_cons_cbs", "tcpslb_cbs");
     if(tcpslb_accept_cons_cbs==NULL){
	     printk("did not get tcpslb_cbs where is it?");
	     ok=1;
	     return 0;
     }
     tcpslb_accept_cons_hash=inter_module_get_request("tcpslb_accept_cons_hash", "tcpslb_hash");
     if(tcpslb_accept_cons_cbs==NULL){
	     printk("did not get tcpslb_hash where is it?");
	     ok=1;
	     return 0;
     }
//     tcpslb_hash_addnode=inter_module_get_request("tcpslb_hash_addnode", "tcpslb_hash");
     
     
   serv=(struct tcpslb_service *)vmalloc(sizeof(struct tcpslb_service));
   serv->next=NULL;
   
     kernel_thread(tcpslb_start_services,NULL,0);


   /*
     serv1=serv;
    serv1->port=2003;  //set the lisetning port.
     serv1->noRealServ=2; 
 
     servers=(struct tcpslb_realservers *)
	     vmalloc(sizeof(struct tcpslb_realservers));
     serv1->realServ=servers;
          
     strcpy(servers->addr,"127.0.0.1");
     servers->port=80;
     servers->next=(struct tcpslb_realservers *)
             vmalloc(sizeof(struct tcpslb_realservers));
     servers=servers->next;
     
     strcpy(servers->addr,"127.0.0.1");
     servers->port=80;
     servers->next=NULL;
	     
     serv1->scheduling = SCHEDULE_RR;  //round robin scheduling
     serv1->tcpslb_cont=1;
     sema_init(&serv1->sem,1);  //semaphore initialized
     
     rr_sched=vmalloc(sizeof(struct tcpslb_sched_rr));
     sema_init(&rr_sched->sem,1);
     rr_sched->server=NULL;
     serv1->data=rr_sched;


    
     serv1->next=(struct tcpslb_service *)vmalloc(sizeof(struct tcpslb_service));
     serv1=serv1->next;
     
     serv->next=serv1;
    
     serv1->port=2004;  //set the lisetning port.
     serv1->noRealServ=2; 
 
     servers=(struct tcpslb_realservers *)
	     vmalloc(sizeof(struct tcpslb_realservers));
     serv1->realServ=servers;
          
     strcpy(servers->addr,"127.0.0.1");
     servers->port=80;
     servers->next=(struct tcpslb_realservers *)
             vmalloc(sizeof(struct tcpslb_realservers));
     servers=servers->next;
     
     strcpy(servers->addr,"192.168.0.2");
     servers->port=80;
     servers->next=NULL;
	     
     serv1->scheduling = SCHEDULE_WRR;  //weighted round robin scheduling
     serv1->tcpslb_cont=1;
     sema_init(&serv1->sem,1);  //semaphore initialized
     
     wrr_sched=vmalloc(sizeof(struct tcpslb_sched_wrr));
     sema_init(&wrr_sched->sem,1);
     wrr_sched->weight[0]=4;
     wrr_sched->weight[1]=1;
     wrr_sched->history[0]=0;
     wrr_sched->history[1]=0;
     serv1->data=wrr_sched;


     serv1->next=(struct tcpslb_service *)vmalloc(sizeof(struct tcpslb_service));
     
     serv1=serv1->next;
    
     serv1->port=2005;  //set the lisetning port.
     serv1->noRealServ=2; 
 
     servers=(struct tcpslb_realservers *)
	     vmalloc(sizeof(struct tcpslb_realservers));
     serv1->realServ=servers;
          
     strcpy(servers->addr,"127.0.0.1");
     servers->port=80;
     servers->next=(struct tcpslb_realservers *)
             vmalloc(sizeof(struct tcpslb_realservers));
     servers=servers->next;
     
     strcpy(servers->addr,"192.168.0.2");
     servers->port=80;
     servers->next=NULL;
	     
     serv1->scheduling = SCHEDULE_LC;  //Least connections scheduling
     serv1->tcpslb_cont=1;
     sema_init(&serv1->sem,1);  //semaphore initialized
     
     lc_sched=vmalloc(sizeof(struct tcpslb_sched_lc));
     sema_init(&lc_sched->sem,1);
     lc_sched->connections[0]=0;
     lc_sched->connections[1]=0;
     serv1->data=lc_sched;

     serv1->next=(struct tcpslb_service *)vmalloc(sizeof(struct tcpslb_service));
     
     serv1=serv1->next;
    
     serv1->port=2006;  //set the lisetning port.
     serv1->noRealServ=2; 
 
     servers=(struct tcpslb_realservers *)
	     vmalloc(sizeof(struct tcpslb_realservers));
     serv1->realServ=servers;
          
     strcpy(servers->addr,"127.0.0.1");
     servers->port=23;
     servers->next=(struct tcpslb_realservers *)
             vmalloc(sizeof(struct tcpslb_realservers));
     servers=servers->next;
     
     strcpy(servers->addr,"192.168.0.2");
     servers->port=80;
     servers->next=NULL;
	     
     serv1->scheduling = SCHEDULE_WLC;  //Least connections scheduling
     serv1->tcpslb_cont=1;
     sema_init(&serv1->sem,1);  //semaphore initialized
     
     wlc_sched=vmalloc(sizeof(struct tcpslb_sched_wlc));
     sema_init(&wlc_sched->sem,1);
     wlc_sched->connections[0]=0;
     wlc_sched->connections[1]=0;
     wlc_sched->weight[0]=2;
     wlc_sched->weight[1]=1;
     serv1->data=wlc_sched;


     serv1->next=(struct tcpslb_service *)vmalloc(sizeof(struct tcpslb_service));
     
     serv1=serv1->next;
    
     serv1->port=2007;  //set the lisetning port.
     serv1->noRealServ=2; 
 
     servers=(struct tcpslb_realservers *)
	     vmalloc(sizeof(struct tcpslb_realservers));
     serv1->realServ=servers;
          
     strcpy(servers->addr,"127.0.0.1");
     servers->port=80;
     servers->next=(struct tcpslb_realservers *)
             vmalloc(sizeof(struct tcpslb_realservers));
     servers=servers->next;
     
     strcpy(servers->addr,"127.0.0.2");
     servers->port=80;
     servers->next=NULL;
	     
     serv1->scheduling = SCHEDULE_CBS;  //Least connections scheduling
     serv1->tcpslb_cont=1;
     sema_init(&serv1->sem,1);  //semaphore initialized
     
     cbs_sched=vmalloc(sizeof(struct tcpslb_sched_cbs));
     sema_init(&cbs_sched->sem,1);
     sema_init(&cbs_sched->sem1,1);
     cbs_sched->content[0]=0;
     cbs_sched->content[1]=0;
     serv1->data=cbs_sched;


     serv1->next=(struct tcpslb_service *)vmalloc(sizeof(struct tcpslb_service));
     
     serv1=serv1->next;
    
     serv1->port=2008;  //set the lisetning port.
     serv1->noRealServ=2; 
 
     servers=(struct tcpslb_realservers *)
	     vmalloc(sizeof(struct tcpslb_realservers));
     serv1->realServ=servers;
          
     strcpy(servers->addr,"127.0.0.1");
     servers->port=80;
     servers->next=(struct tcpslb_realservers *)
             vmalloc(sizeof(struct tcpslb_realservers));
     servers=servers->next;
     
     strcpy(servers->addr,"127.0.0.2");
     servers->port=80;
     servers->next=NULL;
	     
     serv1->scheduling = SCHEDULE_WCBS;  //weighted Least connections scheduling
     serv1->tcpslb_cont=1;
     sema_init(&serv1->sem,1);  //semaphore initialized
     
     wcbs_sched=vmalloc(sizeof(struct tcpslb_sched_wcbs));
     sema_init(&wcbs_sched->sem,1);
     sema_init(&wcbs_sched->sem1,1);
     wcbs_sched->content[0]=0;
     wcbs_sched->content[1]=0;
     wcbs_sched->weight[0]=4;
     wcbs_sched->weight[1]=1;
     serv1->data=wcbs_sched;



     serv1->next=(struct tcpslb_service *)vmalloc(sizeof(struct tcpslb_service));
     
     serv1=serv1->next;
    
     serv1->port=2009;  //set the lisetning port.
     serv1->noRealServ=2; 
 
     servers=(struct tcpslb_realservers *)
	     vmalloc(sizeof(struct tcpslb_realservers));
     serv1->realServ=servers; 
          
     strcpy(servers->addr,"127.0.0.1");
     servers->port=80;
     servers->next=(struct tcpslb_realservers *)
             vmalloc(sizeof(struct tcpslb_realservers));
     servers=servers->next;
     
     strcpy(servers->addr,"192.168.0.2");
     servers->port=80;
     servers->next=NULL;
	     
     serv1->scheduling = SCHEDULE_SHASH;  //fixed source hash scheduling
     serv1->tcpslb_cont=1;
     sema_init(&serv1->sem,1);  //semaphore initialized
     
     hash_sched=(struct tcpslb_sched_hash *)
	     vmalloc(sizeof(struct tcpslb_sched_hash));
     sema_init(&hash_sched->sem,1);
     hash_sched->hash=NULL;
  //   tcpslb_initialize_hash(hash_sched);
     addr[0]=256; addr[1]=0; addr[2]=256; addr[3]=1;
     tcpslb_hash_addnode(hash_sched,addr,serv1->realServ);
     addr[0]=256; addr[1]=0; addr[2]=0; addr[3]=2;
     tcpslb_hash_addnode(hash_sched,addr,serv1->realServ->next);
     serv1->data=hash_sched;


     serv1->next=(struct tcpslb_service *)vmalloc(sizeof(struct tcpslb_service));
     
     serv1=serv1->next;
    
     serv1->port=2010;  //set the lisetning port.
     serv1->noRealServ=2; 
 
     servers=(struct tcpslb_realservers *)
	     vmalloc(sizeof(struct tcpslb_realservers));
     serv1->realServ=servers;
          
     strcpy(servers->addr,"127.0.0.1");
     servers->port=80;
     servers->next=(struct tcpslb_realservers *)
             vmalloc(sizeof(struct tcpslb_realservers));
     servers=servers->next;
     
     strcpy(servers->addr,"192.168.0.2");
     servers->port=80;
     servers->next=NULL;
	     
     serv1->scheduling = SCHEDULE_DHASH;  //fixed destination hash scheduling
     serv1->tcpslb_cont=1;
     sema_init(&serv1->sem,1);  //semaphore initialized
     
     hash_sched=(struct tcpslb_sched_hash *)
	     vmalloc(sizeof(struct tcpslb_sched_hash));
     sema_init(&hash_sched->sem,1);
     hash_sched->hash=NULL;
  //   tcpslb_initialize_hash(hash_sched);
     addr[0]=256; addr[1]=0; addr[2]=256; addr[3]=1;
     tcpslb_hash_addnode(hash_sched,addr,serv1->realServ);
     addr[0]=256; addr[1]=0; addr[2]=0; addr[3]=2;
     tcpslb_hash_addnode(hash_sched,addr,serv1->realServ->next);
     serv1->data=hash_sched;


     serv1->next=NULL;
     
    */ 
    return 0; 
     
     
}

static int tcpslb_start_services(void *data)
{
     struct tcpslb_service *serv1;
     int i;
     static char *envp[] = { "HOME=/", "TERM=linux",
	     "PATH=/sbin:/usr/sbin:/usr/bin:/bin", NULL };
     char *argv0 []= {RMMOD,"tcpslb_rrlc",NULL};
     char *argv1 []= {RMMOD,"tcpslb_cbs",NULL};
     char *argv2 []= {RMMOD,"tcpslb_hash",NULL};
     char *argv9 []= {RMMOD,"tcpslb_config",NULL};
     DECLARE_WAITQUEUE(wait, current);
     
     down_interruptible(config_sem);
#ifdef DEBUG_MESSAGE			
     printk("waiting....");
#endif  
     down_interruptible(config_sem);
#ifdef DEBUG_MESSAGE			
     printk("completed....");
     printk(KERN_ALERT "DESPATCHING SERVICES");
#endif
     for(i=0;i<10;i++) reqd[i]=0;

    serv1=serv->next;

     while(serv1!=NULL){
	     reqd[serv1->scheduling]=1;
              /* 
              * Here we thread to each of the service... 
	      * which will act as the daemons
              */
	     if(serv1->scheduling==SCHEDULE_CBS || 
			     serv1->scheduling==SCHEDULE_WCBS)
	       kernel_thread(tcpslb_accept_cons_cbs,(void *)serv1,0);
	     else if(serv1->scheduling==SCHEDULE_SHASH ||
			     serv1->scheduling==SCHEDULE_DHASH)
	       kernel_thread(tcpslb_accept_cons_hash,(void *)serv1,0);
	     else
	       kernel_thread(tcpslb_accept_cons_generic,(void *)serv1,0);
	     serv1=serv1->next;
     }
     /*
      * Now that we got everything remove all module that we dont want
      */
	if(reqd[SCHEDULE_RR]+reqd[SCHEDULE_WRR]+
			reqd[SCHEDULE_LC]+reqd[SCHEDULE_WLC]==0 ){
	       inter_module_put("tcpslb_accept_cons_generic");
	}
	if(reqd[SCHEDULE_CBS]+reqd[SCHEDULE_WCBS]==0 ){
	       inter_module_put("tcpslb_accept_cons_cbs");
	}
	if(reqd[SCHEDULE_SHASH]+reqd[SCHEDULE_DHASH]==0 ){
	       inter_module_put("tcpslb_accept_cons_hash");
	}


	interruptible_sleep_on_timeout(&wait, HZ);  
	// without this i get an error.... but couldnt 
	// establish why i have to wate some time

	call_usermodehelper(RMMOD,argv9, envp);
	if(reqd[SCHEDULE_RR]+reqd[SCHEDULE_WRR]+
			reqd[SCHEDULE_LC]+reqd[SCHEDULE_WLC]==0 ){
              call_usermodehelper(RMMOD,argv0, envp);
	}
	if(reqd[SCHEDULE_CBS]+reqd[SCHEDULE_WCBS]==0 ){
               call_usermodehelper(RMMOD,argv1, envp);
	}
	if(reqd[SCHEDULE_SHASH]+reqd[SCHEDULE_DHASH]==0 ){
               call_usermodehelper(RMMOD,argv2, envp);
	}



	
     return 0;

}
/* 
 * the cleanup function
 */
static void __exit tcpslb_cleanup(void)
{
	struct tcpslb_service *serv1;
	struct tcpslb_service *temp;
        struct tcpslb_sched_cbs *cbs_sched;
        struct tcpslb_sched_wcbs *wcbs_sched;
        struct tcpslb_sched_hash *hash_sched;
	
#ifdef DEBUG_MESSAGE			
	printk("<1> Bye World ");
#endif	

	if(reqd[SCHEDULE_RR]+reqd[SCHEDULE_WRR]+
			reqd[SCHEDULE_LC]+reqd[SCHEDULE_WLC]!=0 ){
	       inter_module_put("tcpslb_accept_cons_generic");
	}
	if(reqd[SCHEDULE_CBS]+reqd[SCHEDULE_WCBS]!=0 ){
	       inter_module_put("tcpslb_accept_cons_cbs");
	}
	if(reqd[SCHEDULE_SHASH]+reqd[SCHEDULE_DHASH]!=0 ){
	       inter_module_put("tcpslb_accept_cons_hash");
	}


	inter_module_unregister("serv");
	inter_module_unregister("config_sem");
	serv1=serv->next;
	while(serv1!=NULL){
		serv1->tcpslb_cont=0; //message to discontinue the main daemon

		//the main daemon clears the semaphore announcing 
		//it has completed
		down_interruptible(&serv1->sem);
		if(serv->scheduling==SCHEDULE_CBS){
			cbs_sched=(struct tcpslb_sched_cbs *)serv->data;
 		        down_interruptible(&cbs_sched->sem1);
		}
		else if(serv->scheduling==SCHEDULE_WCBS){
			wcbs_sched=(struct tcpslb_sched_wcbs *)serv->data;
 		        down_interruptible(&wcbs_sched->sem1);
		}
		temp=serv1;
		serv1=serv1->next;
		//de allocation of all data begins
		if(temp->scheduling==SCHEDULE_SHASH || 
				temp->scheduling ==SCHEDULE_DHASH ){
		      hash_sched=(struct tcpslb_sched_hash *)temp->data;
                      tcpslb_dealloc_hash(hash_sched->hash);
		}
		vfree(temp->data);
		vfree(temp);
	}
}

static void tcpslb_dealloc_hash(struct tcpslb_hash_node *node){
    if(node==NULL) return;
    tcpslb_dealloc_hash(node->nextLevel);
    tcpslb_dealloc_hash(node->next);
    
}
module_init(tcpslb_init);
module_exit(tcpslb_cleanup);
MODULE_LICENSE("GPL");

