

#define MAXSERVERS 25     
//decides the maximum servres...used in static allcation of arrays
#define MAX_WAIT_QUEUE 40
//decides how many clients may be kept waiting before providing service
/*
 *  Scheduling alogorithms 
 */
#define SCHEDULE_RR   0   //Round robin
#define SCHEDULE_WRR  1   //Weighted round robin
#define SCHEDULE_LC   2   //Least Connections
#define SCHEDULE_WLC  3   //Weighted Least connections
#define SCHEDULE_CBS  4   //Content Based Scheduling
#define SCHEDULE_WCBS 5   //Weighted Content Based Scheduling
#define SCHEDULE_SHASH 6   //Static Source Hash Scheduling
#define SCHEDULE_DHASH 7   //Static Destination Hash Scheduling

/*
 * A linked list to contain the list of realservres
 */
struct tcpslb_realservers {
    char addr[30];  //this may be ip number in string
    int port;
    struct tcpslb_realservers *next;
};

/*
 * The service  structures .. also a linked list
 */
struct tcpslb_service {
	int port;                             //listening port
	int noRealServ;                       // No of real servers
	struct tcpslb_realservers *realServ;  //linked list of real servers
	int scheduling;                       //Scheduling Algorithm used
	int tcpslb_cont;                      //used to terminate the service
	struct semaphore sem;                 //used by cleanup to find if 
	                                      //daemon is up
	void *data;                           //alorithm specific data
	struct tcpslb_service *next;          //next service
};

/*
 * A structure used by cross connection subroutine
 */
struct tcpslb_cons {
	struct socket *srcSock;
	struct tcpslb_realservers *realServ;
	struct tcpslb_service *service;
};



