#define MODULE
#define __NO_VERSION__
#define CONFIG_PROG "/usr/sbin/tcpslb_configure"
#include<linux/module.h>
#include<linux/kernel.h>
#include<linux/vmalloc.h>
#include<linux/fs.h>
#include<linux/init.h>
#include<linux/kmod.h>
#include<asm/uaccess.h>

#include "tcpslb.h"
#include "rrlc.h"
#include "cbs.h"
#include "hash.h"

#define BUF_LEN 80


#define SCHEDULE  0
#define L_PORT    1
#define OPEN_BRAC 2
#define SERV_ADDR 3
#define SERV_PORT 4
#define SERV_WT   5
#define SERV_HIS  6
#define CLOSE_BRAC 7
#define CLOSE 8
#define OPEN 9
#define SERV_NUM 10

#define RR  8
#define WRR 9
#define LC  10
#define WLC 11
#define CBS 12
#define WCBS 13




int tcpslb_next_token=-1;

char s2[50];
int tcpslb_current_alg;
int tcpslb_count,tcpslb_hash,tcpslb_serv_num,tcpslb_i,tcpslb_j,tcpslb_k;
int tcpslb_realcount;
static __u16 tcpslb_in_atoi(char *str);

	
ssize_t mydev_write(struct file *filp,const char *cptr,size_t n,loff_t *offp);

extern struct tcpslb_service *serv;
struct semaphore *config_sem;

struct file_operations mydev_fops={
write: mydev_write,
};
unsigned int result;
struct inode *inode;
int bytes_read,tcpslb_str,tcpslb_addr[4];

static struct tcpslb_service *serv1;
struct tcpslb_realservers *servers;
struct tcpslb_sched_rr *rr_sched;
struct tcpslb_sched_wrr *wrr_sched;
struct tcpslb_sched_lc *lc_sched;
struct tcpslb_sched_wlc *wlc_sched;
struct tcpslb_sched_cbs *cbs_sched;
struct tcpslb_sched_wcbs *wcbs_sched;
struct tcpslb_sched_hash *hash_sched;
struct tcpslb_realservers *tcpslb_temp;


extern int tcpslb_hash_addnode(struct tcpslb_sched_hash *sched,int *addr,
		                struct tcpslb_realservers *dest);

int device;
int tcpslb_read_conf(void *blank);
char param[256];

/* The function below registers the device */

int __init my_init(void)
{
        unsigned int result;
	int i,pow;
	
#ifdef DEBUG_MESSAGE	
	printk("hi i am the primary module\n");
#endif
	config_sem=(struct semaphore *) inter_module_get("config_sem");
	
	result=register_chrdev(0,"tcpslb",&mydev_fops);
	device=result;
	
	if(result<0){
		printk("can't get major\n");
		return result;
	}
        printk("GOT A DEVICE =%d-",result);
	
	i=0;
	pow=1;
	while(result>pow){
	       	i++;              //finding no of digits
		pow=pow*10;
	}
	
	param[i]=0;         //setting terminal null character
	while(result!=0){           //coverting int to string
		param[--i]=result%10+0x30;    
		result=result/10;
	}
        printk("GOT A DEVICE =%s-",param);

   	kernel_thread(tcpslb_read_conf,NULL,0);
				
	return 0;
}

int tcpslb_read_conf(void *blank)
{
	char *argv[]={param,NULL};
        call_usermodehelper(CONFIG_PROG,argv, NULL);
	return 0;
	
}

void __exit my_cleanup(void)
{
	printk("goodbye - have a nice day");
	unregister_chrdev(device,"tcpslb");
	inter_module_put("config_sem");
		
}

ssize_t mydev_write(struct file *filename,const char *cptr,size_t n,loff_t *offp)
{
       

        char s1[50];
	int i;
	copy_from_user(s1,cptr,n); 
       	/* 
	 * A function which copies the contents from the user space 
	 * to the kernel space
	 */ 
	s1[n]='\0';
	/* 
	 * tcpslb_next_token initially set to -1
	 * check whether it is SCHEDULE
	 */ 
	if(tcpslb_next_token==SCHEDULE)
	{
#ifdef DEBUG_MESSAGE	
		printk("%d this is scheduling %s\n",tcpslb_count,s2);
#endif	
		/* 
		 * If the token is SCHEDULE_RR then set the corresponding
		 * entries. Create the node for this service and link
		 */ 
		
		if(strcmp(s2,"SCHEDULE_RR\n")==0){
		      serv1=serv;
		      while(serv1->next!=NULL)
		      {
			      serv1=serv1->next;
		      }
		      serv1->next=(struct tcpslb_service *)vmalloc(
				      sizeof(struct tcpslb_service));
		      serv1=serv1->next;
		      serv1->scheduling=SCHEDULE_RR;
		      tcpslb_current_alg=SCHEDULE_RR;
		      sema_init(&serv1->sem,1);  //semaphore initialized
		      rr_sched=vmalloc(sizeof(struct tcpslb_sched_rr));
		      sema_init(&rr_sched->sem,1);
		      rr_sched->server=NULL;
		      serv1->data=rr_sched;
		}
		
		/* 
		 * If the token is SCHEDULE_WRR then set the corresponding
		 * entries. Create the node for this service and link
		 */
		
		else if(strcmp(s2,"SCHEDULE_WRR\n")==0){
			printk("chk1");
			serv1=serv;
		        while(serv1->next!=NULL)
		        {
				serv1=serv1->next;
			}
			serv1->next=(struct tcpslb_service *)vmalloc(
			                      sizeof(struct tcpslb_service));
                        serv1=serv1->next;
                        serv1->scheduling=SCHEDULE_WRR;
                        tcpslb_current_alg=SCHEDULE_WRR;
                        sema_init(&serv1->sem,1);  //semaphore initialized
                        wrr_sched=vmalloc(sizeof(struct tcpslb_sched_wrr));
                        sema_init(&wrr_sched->sem,1);
			for(i=0;i<MAXSERVERS;i++)
				wrr_sched->history[i]=0;
                        serv1->data=wrr_sched;
		}
		
		/* 
		 * If the token is SCHEDULE_LC then set the corresponding
		 * entries. Create the node for this service and link
		 */
		
		else if(strcmp(s2,"SCHEDULE_LC\n")==0){
			serv1=serv;
		        while(serv1->next!=NULL)
			{
			        serv1=serv1->next;
			}
			serv1->next=(struct tcpslb_service *)vmalloc(
			sizeof(struct tcpslb_service));
			serv1=serv1->next;
			serv1->scheduling=SCHEDULE_LC;
			tcpslb_current_alg=SCHEDULE_LC;
			sema_init(&serv1->sem,1);  //semaphore initialized
			lc_sched=vmalloc(sizeof(struct tcpslb_sched_lc));
			sema_init(&lc_sched->sem,1);
			for(i=0;i<MAXSERVERS;i++)
				lc_sched->connections[i]=0;
			serv1->data=lc_sched;
		} 
		
		/* 
		 * If the token is SCHEDULE_WLC then set the corresponding
		 * entries. Create the node for this service and link
		 */
		
		else if(strcmp(s2,"SCHEDULE_WLC\n")==0){
			serv1=serv;
			while(serv1->next!=NULL)
			{
				serv1=serv1->next;
			}
			serv1->next=(struct tcpslb_service *)vmalloc(
			sizeof(struct tcpslb_service));
			serv1=serv1->next;
			serv1->scheduling=SCHEDULE_WLC;
			tcpslb_current_alg=SCHEDULE_WLC;
			sema_init(&serv1->sem,1);  //semaphore initialized
			wlc_sched=vmalloc(sizeof(struct tcpslb_sched_wlc));
			sema_init(&wlc_sched->sem,1);
			for(i=0;i<MAXSERVERS;i++)
				wlc_sched->connections[i]=0;
			serv1->data=wlc_sched;
		}
		
		/* 
		 * If the token is SCHEDULE_CBS then set the corresponding
		 * entries. Create the node for this service and link
		 */
		
	 	else if(strcmp(s2,"SCHEDULE_CBS\n")==0){
			serv1=serv;
	                while(serv1->next!=NULL)
			{
				serv1=serv1->next;
			}
		        serv1->next=(struct tcpslb_service *)vmalloc(
			sizeof(struct tcpslb_service));
			serv1=serv1->next;
			serv1->scheduling=SCHEDULE_CBS;
			tcpslb_current_alg=SCHEDULE_CBS;
			sema_init(&serv1->sem,1);  //semaphore initialized
			cbs_sched=vmalloc(sizeof(struct tcpslb_sched_cbs));
			sema_init(&cbs_sched->sem,1);
			sema_init(&cbs_sched->sem1,1);
			for(i=0;i<MAXSERVERS;i++)
				cbs_sched->content[i]=0;
			serv1->data=cbs_sched;
		}	

		/* 
		 * If the token is SCHEDULE_WCBS then set the corresponding
		 * entries. Create the node for this service and link
		 */
		
		else if(strcmp(s2,"SCHEDULE_WCBS\n")==0){
			serv1=serv;
			while(serv1->next!=NULL)
			{
				serv1=serv1->next;
			}
			serv1->next=(struct tcpslb_service *)vmalloc(
			sizeof(struct tcpslb_service));
			serv1=serv1->next;
			serv1->scheduling=SCHEDULE_WCBS;
			tcpslb_current_alg=SCHEDULE_WCBS;
			sema_init(&serv1->sem,1);  //semaphore initialized
			wcbs_sched=vmalloc(sizeof(struct tcpslb_sched_wcbs));
			sema_init(&wcbs_sched->sem,1);
			sema_init(&wcbs_sched->sem1,1);
			for(i=0;i<MAXSERVERS;i++)
				wcbs_sched->content[i]=0;
			serv1->data=wcbs_sched;
		}

		/* 
		 * If the token is SCHEDULE_SHASH then set the corresponding
		 * entries. Create the node for this service and link
		 */
		
		else if(strcmp(s2,"SCHEDULE_SHASH\n")==0){
			serv1=serv;
			while(serv1->next!=NULL)
			{
				serv1=serv1->next;
			}
			serv1->next=(struct tcpslb_service *)vmalloc(
			sizeof(struct tcpslb_service));
			serv1=serv1->next;
			serv1->scheduling=SCHEDULE_SHASH;
                        tcpslb_current_alg=SCHEDULE_SHASH;
                        sema_init(&serv1->sem,1);  //semaphore initialized
                        hash_sched=vmalloc(sizeof(struct tcpslb_sched_hash));
                        sema_init(&hash_sched->sem,1);
                        hash_sched->hash=NULL;
                        serv1->data=hash_sched;
		}

		/* 
		 * If the token is SCHEDULE_DHASH then set the corresponding
		 * entries. Create the node for this service and link
		 */
		
		else if(strcmp(s2,"SCHEDULE_DHASH\n")==0){
			serv1=serv;
			while(serv1->next!=NULL)
			{
				serv1=serv1->next;
			}
			serv1->next=(struct tcpslb_service *)vmalloc(
			                      sizeof(struct tcpslb_service));
			serv1=serv1->next;
			serv1->scheduling=SCHEDULE_DHASH;
			tcpslb_current_alg=SCHEDULE_DHASH;
	                sema_init(&serv1->sem,1);  //semaphore initialized
	                hash_sched=vmalloc(sizeof(struct tcpslb_sched_hash));
	                sema_init(&hash_sched->sem,1);
	                hash_sched->hash=NULL;
	                serv1->data=hash_sched;
		}
		strcpy(s2,s1);//Here s1 is used for look ahead of one token
		s2[n]='\0';
		tcpslb_next_token=L_PORT;//The next token will be listening port
		tcpslb_count++;
	}
	
	/*
	 * The current token is listening port. Make corresponding entries
	 */ 
	else if(tcpslb_next_token==L_PORT)
	{
	#ifdef DEBUG_MESSAGE      
		printk("%d this is listening port %s\n",tcpslb_count,s2);
	#endif
		serv1->port=tcpslb_in_atoi(s2);
		strcpy(s2,s1);
		s2[n]='\0';
		tcpslb_next_token=OPEN_BRAC; /* Next token is open bracket */
		tcpslb_count++;
	}
	/*
	 * The current token is open bracket. Create the node for the 
	 * real servers 
	 */
	 
	else if(tcpslb_next_token==OPEN_BRAC)
        {
	#ifdef DEBUG_MESSAGE       
		printk("%d this is open bracket %s\n",tcpslb_count,s2);
	#endif	
		servers=(struct tcpslb_realservers *)
			             vmalloc(sizeof(struct tcpslb_realservers));
		serv1->realServ=servers;
			
		strcpy(s2,s1);
		s2[n]='\0';
		tcpslb_next_token=SERV_ADDR;/*The next token is Server Address*/
		tcpslb_count++;
	}

	/*
	 * The current token is Server Address. Corresponding entries for 
	 * server address are made. Here decision is made to see whether 
	 * the next token is  port or the "[". The token "[" appears as next
	 * token to server address only in Source_hash and Destination_hash
	 * algorithms
	 */
       	
	else if(tcpslb_next_token==SERV_ADDR)
        {
	 #ifdef DEBUG_MESSAGE        
		printk("%d this is serv addr %s\n",tcpslb_count,s2);
	 #endif
		
		/* 
		 * If the algorithm is Source_hash or the Destination_hash
		 * then next token is set as shown.
		 * The address is split on the "." and these are stored in
		 * an array and passed to the function which makes decision 
		 * about scheduling by making use of these fields
		 */
		
		if(tcpslb_hash==1)
		{
			tcpslb_next_token=SERV_NUM;
			tcpslb_k=0;
		for(tcpslb_i=0;tcpslb_i<=strlen(s2);tcpslb_i++)
		{
			tcpslb_j=0;
			tcpslb_addr[tcpslb_k]=0;
			while(s2[tcpslb_i]!='.')
			{
				if(s2[tcpslb_i]=='\0')
					break;
				tcpslb_str=s2[tcpslb_i]-48;
				tcpslb_addr[tcpslb_k]=tcpslb_addr[tcpslb_k]*10+tcpslb_str;
				tcpslb_i++;
				if(tcpslb_addr[tcpslb_k]==-38)
					tcpslb_addr[tcpslb_k]=256;
			}
			tcpslb_k++;
		}

		}
		
		/* 
		 * Otherwise set the appropriate fields and the next token
		 * will be the port number
		 */
	       	
		else
		{
			s2[strlen(s2)-1]='\0';
			strcpy(servers->addr,s2);
			tcpslb_next_token=SERV_PORT;
		}
		strcpy(s2,s1);
		s2[n]='\0';
		tcpslb_count++;
	}

	/*
	 * The token below is the server number token which is used by the 
	 * Source_hash and Destination_hash algorithms to decide which server
	 * among the real servers to use.
	 */ 
	
	else if(tcpslb_next_token==SERV_NUM)
	{
	 #ifdef DEBUG_MESSAGE	
		printk("%d this is server number %s\n",tcpslb_count,s2);
	 #endif
		tcpslb_serv_num=0;
		tcpslb_str=0;
		tcpslb_i=0;
		
//	        tcpslb_temp=(struct tcpslb_realservers *)
//	                            vmalloc(sizeof(struct tcpslb_realservers));
		tcpslb_temp=serv1->realServ;
		/*
		 * If the next token is "]" then next token is set to CLOSE
		 * Otherwise it is set to Server_address.
		 */ 
		
                if(s1[0]==']')
			tcpslb_next_token=CLOSE;
		else
		        tcpslb_next_token=SERV_ADDR;

		 
		for(tcpslb_i=0;tcpslb_i<strlen(s2);tcpslb_i++)
		  {
		             /* if(s2[tcpslb_i]=='\0')
		                     break;*/
		              tcpslb_str=s2[tcpslb_i]-48;
		              tcpslb_serv_num=tcpslb_serv_num*10+tcpslb_str;
		  }
		
                printk("%d is the server number \n",tcpslb_serv_num);

		/*
		 * The following part of the code takes care of selecting 
		 * the appropriate real server as mentioned in the 
		 * Server number field.
		 */ 
                if(tcpslb_serv_num==1)
	        {
			tcpslb_hash_addnode(hash_sched,tcpslb_addr,
					tcpslb_temp);
			printk("\n-%d-%d-%d-%d-\n",tcpslb_addr[0],
				tcpslb_addr[1],tcpslb_addr[2],tcpslb_addr[3]);
	        }
                else
                {
                        for(tcpslb_i=0;tcpslb_i<tcpslb_serv_num-1;tcpslb_i++)
                        {
				tcpslb_temp=tcpslb_temp->next;
			}
			tcpslb_hash_addnode(hash_sched,tcpslb_addr,tcpslb_temp);
			printk("\n-%d-%d-%d-%d-\n",tcpslb_addr[0],
				tcpslb_addr[1],tcpslb_addr[2],tcpslb_addr[3]);
		}
		strcpy(s2,s1);
		tcpslb_count++;
	}
                                                                     		
	/* The current token is the server port number. At this point there
	 * are some options  
	 * 1) the next token may be "}" in which case the next token is 
	 *     closing bracket. So there are no more real servers and hence
	 *     the last node's next field is set to NULL
	 * 2) If not a closing bracket and is the RR or CBS or LC scheduling 
	 *    alg then next token will be the server address
	 * 3) If not a closing bracket and is either source_hash or the 
	 *     destination_hash alg there are two cases
	 *     i) If next token is "[" then the next token is open square
	 *        bracket. When this token appears then there are no more 
	 *        real servers.So last node's next field is set to NULL.
	 *    ii) Otherwise the next token will be the Server address 
	 *        create the node for the next server
	 * 4) If not all of the above then the next token is server weight  
	 */
       	
	else if(tcpslb_next_token==SERV_PORT)
        {
	 #ifdef DEBUG_MESSAGE  
		printk("-%d this is server port %s\n",tcpslb_count,s2);
	 #endif
		servers->port=tcpslb_in_atoi(s2);
		if(s1[0]=='}')
		{
			tcpslb_next_token=CLOSE_BRAC;
			servers->next=NULL;
			serv1->noRealServ=tcpslb_realcount+1;
			serv1->tcpslb_cont=1;
		}
		else if(tcpslb_current_alg==SCHEDULE_WRR ||
				tcpslb_current_alg==SCHEDULE_WLC ||
				tcpslb_current_alg==SCHEDULE_WCBS ){
			tcpslb_next_token=SERV_WT;
			printk("chk2");
		}
		else if(tcpslb_current_alg==SCHEDULE_RR ||
			tcpslb_current_alg==SCHEDULE_LC ||
			tcpslb_current_alg==SCHEDULE_CBS){
				tcpslb_next_token=SERV_ADDR;
				servers->next=(struct tcpslb_realservers *)
				     vmalloc(sizeof(struct tcpslb_realservers));
				servers=servers->next;
				tcpslb_realcount++;
		
		}
		else if(tcpslb_current_alg==SCHEDULE_SHASH ||
			tcpslb_current_alg==SCHEDULE_DHASH){
			if(s1[0]=='['){
				tcpslb_next_token=OPEN;
				servers->next=NULL;
	                        serv1->noRealServ=tcpslb_realcount+1;
	                        serv1->tcpslb_cont=1;
			}
			else
			{	
				tcpslb_next_token=SERV_ADDR;
				servers->next=(struct tcpslb_realservers *)
				     vmalloc(sizeof(struct tcpslb_realservers));
				servers=servers->next;
				tcpslb_realcount++;
			}
		}

		strcpy(s2,s1);
		s2[n]='\0';
		tcpslb_count++;
	}

	/*
	 * The current algorithm has the information about the server weight
	 * For the algorithms which maintains the information about the 
	 * server weight the corresponding weight entry is made
	 * Nextly depending upon the next token some decisions are made
	 *  i) If the next token is closing bracket then there are no more 
	 *     real servers and the entry for the number of real servers
	 *     is made.
	 * ii) Otherwise the next token is Server address.
	 */

	else if(tcpslb_next_token==SERV_WT)
	{
	 #ifdef DEBUG_MESSAGE
		printk("%d this is server weight is %s\n",tcpslb_count,s2);
	 #endif	
		
		if(tcpslb_current_alg==SCHEDULE_WRR){
			wrr_sched->weight[tcpslb_realcount]=tcpslb_in_atoi(s2);
			wrr_sched->history[tcpslb_realcount]=0;
		}
		else if(tcpslb_current_alg==SCHEDULE_WLC)
			wlc_sched->weight[tcpslb_realcount]=tcpslb_in_atoi(s2);

		else if(tcpslb_current_alg==SCHEDULE_WCBS)
			wcbs_sched->weight[tcpslb_realcount]=tcpslb_in_atoi(s2);
		
		if(s1[0]=='}')
		{
			tcpslb_next_token=CLOSE_BRAC;
			servers->next=NULL;
		        serv1->noRealServ=tcpslb_realcount+1;
		        serv1->tcpslb_cont=1;
		}
		else{
			tcpslb_next_token=SERV_ADDR;
			servers->next=(struct tcpslb_realservers *)
                		vmalloc(sizeof(struct tcpslb_realservers));
		        servers=servers->next;
			tcpslb_realcount++;

		}
		
		strcpy(s2,s1);
		s2[n]='\0';
		tcpslb_count++;
						
	}				

	/*
	 * This is the token which we have made use in the Source_hash 
	 * and Destination_hash algorithms.
	 * So whenever this appears a flag is set for identification.
	 * And the next token will be Server address.
	 */ 
	
	else if(tcpslb_next_token==OPEN)
	{
	 #ifdef DEBUG_MESSAGE	
		printk("%d this is open brac %s\n",tcpslb_count,s2);
	 #endif
		tcpslb_hash=1;
		tcpslb_next_token=SERV_ADDR;
	        strcpy(s2,s1);
	        tcpslb_count++;
	}
	
	/*
	 * This is the token which we have made use in the Source_hash
	 * and Destination_hash algorithms.
	 * Whenever this appears flag is reset.
	 * And next token is Closing Bracket ("}").          
	 */
	
	else if(tcpslb_next_token==CLOSE)
	{
	 #ifdef DEBUG_MESSAGE	
		printk("%d this is close brac %s\n",tcpslb_count,s2);
	 #endif	
		tcpslb_hash=0;
		tcpslb_next_token=CLOSE_BRAC;
		strcpy(s2,s1);
		tcpslb_count++;
	}
	
	/*
	 * This token indicates the end of the details about a particular
	 * service.
	 * The next token is either the information pertaining to the next
	 * service, wherein it will be the information about the Scheduling
	 * algorithm  OR it will the End Of File marker.
	 */ 
	
	else if(tcpslb_next_token==CLOSE_BRAC)
	{
	 #ifdef DEBUG_MESSAGE 
		printk("%d this is closing bracket %s\n",tcpslb_count,s2);
	 #endif				    
		if(strcmp(s1,"EOF\n")==0)
		{
	      		serv1->next=NULL;// Set the next field to NULL		
			printk("EEEK");
			/* 
			 * Giving control back to tcpslb.c module by bringing
			 * up the Semaphore
			 */
			up(config_sem);
		}
		serv1->next=NULL;// Set service's next field to NULL
		strcpy(s2,s1);
		s2[n]='\0';
		tcpslb_next_token=SCHEDULE;
		tcpslb_count++;
		printk("The number of real servers are %d\n",tcpslb_realcount+1);
		tcpslb_realcount=0;
	}
	
	/*
	 * Initial token set to -1.
	 * next token will be the token which says about which
	 * Scheduling algorithm.
	 */ 
	
	else if(tcpslb_next_token==-1)
	{
		strcpy(s2,s1);
		s2[n]='\0';
		tcpslb_next_token=SCHEDULE;
		tcpslb_count=1;
	#ifdef DEBUG_MESSAGE	
		printk("%d is tcpslb_count\n",tcpslb_count);
	#endif
		printk("tcpslb_realcount is %d\n",tcpslb_realcount);
//		serv=(struct tcpslb_service *)vmalloc(sizeof(struct tcpslb_service));
//		serv->next=NULL;
		serv1=serv;
	}
	// printk(KERN_ALERT "<1>kernel reply is %s\n",s1);
        return n;

}
MODULE_LICENSE("GPL");			
module_init(my_init);
module_exit(my_cleanup);


 
static __u16 tcpslb_in_atoi(char *str)
{
	int l;
	char *ptr;
	ptr=str;
	l = 0;
	while(*ptr!='\0'){
		if(*ptr!='\n')
		  l=l*10+ *ptr - 0x30;
		ptr++;
	}
	printk("-%d-",l);
	return(l);
}

